SystemOrganization addCategory: #'Ma proxy support'!
SystemOrganization addCategory: #'Ma proxy support-Base'!
SystemOrganization addCategory: #'Ma proxy support-Exceptions'!

MaNotification subclass: #MaTraverseProxyNotification
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma proxy support-Exceptions'!

!MaTraverseProxyNotification class methodsFor: 'as yet unclassified' stamp: 'cmm 1/30/2005 20:26'!
proxy: aMaMutatingProxy

	^ self new
		proxy: aMaMutatingProxy ;
		yourself! !

!MaTraverseProxyNotification methodsFor: 'accessing' stamp: 'cmm 1/30/2005 20:27'!
proxy
	^ proxy! !

!MaTraverseProxyNotification methodsFor: 'accessing' stamp: 'cmm 1/30/2005 20:27'!
proxy: aMaMutatingProxy

	proxy _ aMaMutatingProxy! !

PackageInfo subclass: #MaProxySupportPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma proxy support-Base'!

!MaProxySupportPackageInfo class methodsFor: 'as yet unclassified' stamp: 'cmm 3/20/2009 18:42'!
packageName
	^ 'Ma proxy support'! !

!MaProxySupportPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 3/20/2009 16:03'!
prerequisitePackageNames
	^ super prerequisitePackageNames , {  (MaExceptionHandlingPackageInfo packageName)  }! !

ProtoObject subclass: #MaMinimalObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma proxy support'!

!MaMinimalObject commentStamp: 'cmm 1/13/2005 14:25' prior: 0!
I am the main superclass for objects with a minimal api.  I am meant to have just enough api to be able to develop and debug.!

MaMinimalObject subclass: #MaForwardingProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma proxy support'!

!MaForwardingProxy methodsFor: 'as yet unclassified' stamp: 'cmm 1/13/2005 16:21'!
doesNotUnderstand: aMessage

	^ self
		forward: aMessage
		to: self realObject! !

!MaForwardingProxy methodsFor: 'as yet unclassified' stamp: 'cmm 1/13/2005 16:20'!
forward: aMessage to: anObject

	^ aMessage sendTo: anObject! !

!MaForwardingProxy methodsFor: 'as yet unclassified' stamp: 'cmm 1/13/2005 17:15'!
maIsForwardingProxy

	^ true! !

!MaForwardingProxy methodsFor: 'as yet unclassified' stamp: 'cmm 7/5/2009 20:00'!
maOriginalClass
	"Serialization wants to know this."
	^ self class! !

!MaForwardingProxy methodsFor: 'as yet unclassified' stamp: 'cmm 1/13/2005 16:22'!
realObject

	self subclassResponsibility! !

!MaForwardingProxy methodsFor: 'as yet unclassified' stamp: 'cmm 7/5/2009 19:58'!
respondsTo: aSymbol 
	"Serialization wants to know whether I #respondsTo: aSymbol."
	^ (self class canUnderstand: aSymbol) or: [ self realObject respondsTo: aSymbol ]! !

!MaMinimalObject methodsFor: 'Public methods' stamp: ''!
= anObject 
	"Answer whether the receiver and the argument represent the same 
	object. If = is redefined in any subclass, consider also redefining the 
	message hash."

	^self == anObject! !

!MaMinimalObject methodsFor: 'printing' stamp: 'kph 7/14/2007 05:48'!
asExplorerString
	^ self printString! !

!MaMinimalObject methodsFor: 'Public methods' stamp: ''!
basicSize
	"Primitive. Answer the number of indexable variables in the receiver. 
	This value is the same as the largest legal subscript. Essential. Do not 
	override in any subclass. See Object documentation whatIsAPrimitive."

	<primitive: 62>
	"The number of indexable fields of fixed-length objects is 0"
	^0 ! !

!MaMinimalObject methodsFor: 'actions' stamp: 'cmm 1/13/2005 13:46'!
becomeForward: otherObject copyHash: copyHash
	"Primitive. All variables in the entire system that used to point to the receiver now point to the argument.
	If copyHash is true, the argument's identity hash bits will be set to those of the recevier.
	Fails if either argument is a SmallInteger."

	(Array with: self)
		elementsForwardIdentityTo:
			(Array with: otherObject)
				copyHash: copyHash! !

!MaMinimalObject methodsFor: 'accessing' stamp: ''!
class

	^self proxyClass
! !

!MaMinimalObject methodsFor: 'actions' stamp: ''!
error: aString

	"Stop the currently executing process and display
	 the error message aString."

	^nil error: aString
! !

!MaMinimalObject methodsFor: 'debugging' stamp: ''!
halt
	"This is the typical message to use for inserting breakpoints during 
	debugging. It behaves like halt:, but does not call on halt: in order to 
	avoid putting this message on the stack. Halt is especially useful when 
	the breakpoint message is an arbitrary one."

	Halt signal
! !

!MaMinimalObject methodsFor: 'debugging' stamp: ''!
halt: aString 
	"This is the typical message to use for inserting breakpoints during 
	debugging. It creates and schedules a Notifier with the argument, 
	aString, as the label."
	
	Halt new signal: aString
! !

!MaMinimalObject methodsFor: 'debugging' stamp: 'cmm 12/1/2004 14:28'!
inspect
	"Create and schedule an Inspector in which the user can examine the receiver's variables."

	self inspectorClass openOn: self withEvalPane: true
! !

!MaMinimalObject methodsFor: 'debugging' stamp: 'cmm 12/1/2004 14:28'!
inspectorClass

	^ Inspector! !

!MaMinimalObject methodsFor: 'accessing' stamp: 'cmm 12/25/2002 00:44'!
instVarAt: index 
	"Primitive. Answer a fixed variable in an object. The numbering of the 
	variables corresponds to the named instance variables. Fail if the index 
	is not an Integer or is not the index of a fixed variable. Essential. See 
	Object documentation whatIsAPrimitive."

	"Access beyond fixed variables."

	<primitive: 73>
	self primitiveFailed! !

!MaMinimalObject methodsFor: 'accessing' stamp: 'cmm 8/11/2007 12:08'!
instVarAt: anInteger put: anObject 
	"Primitive. Store a value into a fixed variable in the receiver. The 
	numbering of the variables corresponds to the named instance variables. 
	Fail if the index is not an Integer or is not the index of a fixed variable. 
	Answer the value stored as the result. Using this message violates the 
	principle that each object has sovereign control over the storing of 
	values into its instance variables. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 74>
	"Access beyond fixed fields"
	^self error: 'primitive failed updating object'! !

!MaMinimalObject methodsFor: 'testing' stamp: 'cmm 5/4/2005 11:15'!
isBehindWriteBarrier
	"Proxy's don't change anyway.."

	^ false! !

!MaMinimalObject methodsFor: 'testing' stamp: 'cmm 2/15/2005 10:45'!
isMorph
	"this is here to satisfy CommandHistory."

	^ false! !

!MaMinimalObject methodsFor: 'private' stamp: 'cmm 12/25/2002 00:42'!
primitiveFailed
	"Announce that a primitive has failed and there is no appropriate 
	Smalltalk code to run."

	self error: 'a primitive has failed'! !

!MaMinimalObject methodsFor: 'printing' stamp: ''!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."

	| title |
	title _ self class name.
	aStream
		nextPutAll: (title first isVowel ifTrue: ['an '] ifFalse: ['a ']);
		nextPutAll: title
! !

!MaMinimalObject methodsFor: 'printing' stamp: 'cmm 12/25/2002 00:41'!
printString
	"Answer a String whose characters are a description of the receiver. 
	If you want to print without a character limit, use fullPrintString."

	^String streamContents: [ :s | self printOn: s ]! !

!MaMinimalObject methodsFor: 'accessing' stamp: ''!
proxyClass

	"Answer a Class which is the receiver's class"

	<primitive: 111>
	self primitiveFailed
! !

!MaMinimalObject methodsFor: 'Public methods' stamp: 'cmm 1/16/2005 22:51'!
subclassResponsibility
	"This message sets up a framework for the behavior of the class' subclasses.
	Announce that the subclass should have implemented this message."

	self error: 'My subclass should have overridden ', thisContext sender methodSelector printString! !

!MaMinimalObject methodsFor: 'Public methods' stamp: ''!
~= anObject

	"Answer a Boolean which is false when the receiver and anObject
	 are equivalent, and true otherwise."

	^(self = anObject) not! !

MaMinimalObject subclass: #MaMutatingProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma proxy support'!

!MaMutatingProxy methodsFor: 'private' stamp: 'brp 7/2/2008 23:31'!
doesNotUnderstand: aMessage
	"Trying this retry approach to satisfy the case where a Symbol is materialized and immediately used as the argument to perform:.  I discovered this was happening on Morphic objects but I had to set their read depth to 99999 anyway."
	| didRetry |
	didRetry := false.

	^ [ self maIsMutatingProxy 
			ifTrue: [ self mutateAndSend: aMessage ] 
			ifFalse: [ aMessage sendTo: self ] ]
		on: MessageNotUnderstood 
		do:
			[ :err |
			didRetry
				ifFalse: 	[ didRetry := true. err retry ]
				ifTrue: [ self errorCannotMutate ] ]
! !

!MaMutatingProxy methodsFor: 'private' stamp: 'brp 7/2/2008 23:31'!
errorCannotMutate

	 self	
		becomeForward: 'Unable to realize Orphaned MagmaMutatingProxy' 
		copyHash: false! !

!MaMutatingProxy methodsFor: 'private' stamp: 'kph 7/14/2007 06:09'!
explorerContents 

	| mutant proxy  |
 
	proxy := self printString.
	mutant := self mutant.	

	^ Array with: (ObjectExplorerWrapper
			with: mutant  
			name: proxy asString
			model: mutant)! !

!MaMutatingProxy methodsFor: 'private' stamp: 'kph 7/14/2007 05:49'!
hasContentsInExplorer

	^true! !

!MaMutatingProxy methodsFor: 'private' stamp: 'kph 7/14/2007 06:15'!
isLiteral

	"hack to allow pointerfinder to work"

	^ true! !

!MaMutatingProxy methodsFor: 'private' stamp: 'cmm 1/13/2005 13:45'!
maIsMutatingProxy

	^ true! !

!MaMutatingProxy methodsFor: 'private' stamp: 'cmm 12/24/2002 16:17'!
mutant
	"subclass responsibility"! !

!MaMutatingProxy methodsFor: 'private' stamp: ''!
mutateAndSend: aMessage

	^self mutant
		perform: aMessage selector
		withArguments: aMessage arguments
! !

!MaMutatingProxy methodsFor: 'private' stamp: 'cmm 7/12/2007 23:23'!
respondsTo: aMessage 
	"this is so that respondsTo can be used on proxies without realizing the object needed for explorers which send respondsTo: #explorerContents"
	^ (self class canUnderstand: aMessage) or: [ self mutant respondsTo: aMessage ]! !

!ProtoObject methodsFor: '*ma proxy support' stamp: 'cmm 1/16/2005 18:07'!
maIsForwardingProxy

	^ false! !

!ProtoObject methodsFor: '*ma proxy support' stamp: 'cmm 1/25/2005 21:54'!
maIsMutatingProxy

	^ false! !
